package pipe.gui;

import javax.swing.*;
import java.awt.*;

/** Class responsible for instantiating handlers to be attached to PetriNetObjects */
public class HandlerFactory {

  public CreateGui gui;
  public Container contentPane;
  public CreateArcHandler createArcHandler= null;

  public HandlerFactory(CreateGui _gui, Container _contentPane){
    gui = _gui;
    contentPane = _contentPane;
  }


  public PlaceHandler getPlaceHandler() {
    return new PlaceHandler(gui,contentPane);
  }

  public TransitionHandler getTransitionHandler() {
    return new TransitionHandler(gui,contentPane);
  }

  public ArcHandler getArcHandler() {
    return new ArcHandler(gui,contentPane);
  }

  // singleton- we only want one handler for arc creation per model.
  public  CreateArcHandler getCreateArcHandler() {
    if (createArcHandler == null) {
      // System.out.println("creating new createarc handler");
      createArcHandler = new CreateArcHandler(gui,contentPane);
      return createArcHandler;
    } else {
      // System.out.println("returning existing createarchandler");
      return createArcHandler;
    }

  }

  public AnimationHandler getAnimationHandler(){
    return new AnimationHandler(gui, contentPane);
  }

}

